Package org.apache.jasper.compiler

## Class NewlineReductionServletWriter

- java.lang.Object
- - org.apache.jasper.compiler.ServletWriter
  - - org.apache.jasper.compiler.NewlineReductionServletWriter

All Implemented Interfaces:
  `java.lang.AutoCloseable`

    public class NewlineReductionServletWriter
    extends ServletWriter

This class filters duplicate newlines instructions from the compiler output, and therefore from the runtime JSP. The duplicates typically happen because the compiler has multiple branches that write them, but they operate independently and don't realize that the previous output was identical. Removing these lines makes the JSP more efficient by executing fewer operations during runtime.

### Constructor Summary

Constructors
`NewlineReductionServletWriter​(java.io.PrintWriter writer)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `printil​(java.lang.String s)` Prints the current indentation, and then the string, and a '\n'.

### Methods inherited from class org.apache.jasper.compiler.ServletWriter

`close, getJavaLine, popIndent, print, print, print, printin, printin, println, println, printMultiLn, pushIndent`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NewlineReductionServletWriter

    public NewlineReductionServletWriter​(java.io.PrintWriter writer)

### Method Detail

#### printil

    public void printil​(java.lang.String s)

Description copied from class: `ServletWriter`
Prints the current indentation, and then the string, and a '\n'.

Overrides:
  `printil` in class `ServletWriter`
Parameters:
  `s` - The string